extern "C"{
#include "mv_phapi.h"
}

#define MAX_WIDTH 1024
#define MAX_HEIGHT 768
int img_width = 640;
int img_height = 480;
int fd = -1;
char * buffer;
int flag = 0;
int numitem;
int bpp = 3;
void* formObject;
int devindex = -1;
int oneflag;
//int bfield=0;



void callbackBefore( PVOID pData, PMV_IMAGEINFO pImageInfo, PVOID pUserData)
{
	if(pData != NULL && buffer != NULL)
	{
	               //printf("enter callball function \n");
		memcpy(buffer,(char *)pData,img_width*img_height*bpp);
		flag = 1;
	}
}



void Form1::vga_init()
{
        int x;
	int r,g,b;
	buffer = (char *)malloc(MAX_WIDTH*MAX_HEIGHT*4);
	bupdown = 0;
	bfilp = 0;
	formObject = (void *)this;
	odlg = new OpendeviceDialog(this, "Opendevice Dialog", TRUE);
	odlg->setCallback(&Form1::copybuffer);
	odlg->hide();
	dlg = new ToolDialog(this, "Tool Dialog", TRUE);
	dlg->hide();
	offsetdlg = new OffsetDialog(this, "Offset Dialog", TRUE);
	offsetdlg->hide();
	imagesize=new ImageSizeDialog(this, "ImageSize Dialog", TRUE);
	imagesize->setCallback(&Form1::formresize);
	imagesize->hide();
	timer = new QTimer(this);
	image = new QImage();
	p = new QPainter;
	for(x=0; x<256; x++)
        {
		{
                r=(int)x;
                g=(int)x;
                b=(int)x;
                point1[x] = qRgb(r,g,b);
		}  
         }
}

void Form1::Start()
{
    qDebug("\n start to capture");
    if(fd > 0)
    {
    this->resize( QSize(img_width, img_height+70));
    MV_OperateDevice(fd,MVRUN);
    }
}

void Form1::Play()
{
    
    if(MV_OperateDevice(fd,MVQUERYSTATU) == MVRUN)
    {
	qDebug("start to display\n");
	connect (timer, SIGNAL (timeout ()), SLOT (display()));
	timer->start(5);
    }
    else
	qDebug("no image to display\n");
}

void Form1::UnPlay()
{
	timer->stop();
}


void Form1::Pause()
{
    if(fd > 0)
    {
    qDebug("capture Pause!\n");
    MV_OperateDevice(fd,MVPAUSE);
    timer->stop();
    }
}

void Form1::Stop()
{
    if(fd > 0)
    {
    qWarning( "capture Stop\n" );
    MV_OperateDevice(fd,MVSTOP);
    timer->stop();
    }
}

void Form1::Save()
{
    if(fd > 0)
    {
    qDebug("img_width := %d  img_height := %d \n",img_width,img_height);
    qWarning( "Form1::Save(): Not implemented yet" );
    MV_WriteBmp("1.bmp",buffer,img_width,img_height,bpp);
    }
}


void Form1::closeEvent(QCloseEvent *event)
{   
        
	if(fd > 0)
        {
	 qDebug("close device\n");
	 MV_OperateDevice(fd, MVSTOP);
	 qDebug("close device : MV_OperateDevice\n");
	 timer->stop();
	 qDebug("close device : timer->stop\n");
	 sleep(1);
	 MV_CloseDevice(fd);
	 qDebug("close device : MV_CloseDevice\n");
	 fd = -1;
        }
        qDebug("bye bye\n");
	if(buffer != NULL)
	    free(buffer);
	buffer = NULL;
        event->accept();
 }


void Form1::Config()
{
         dlg->show();
}



void Form1::SetImageSize()
{
        imagesize->show();
}

void Form1::display()
{
      if(flag == 1)
      {
	flag = 0;       
	int x, y;
	int i = 0;
	int r, g, b;
	unsigned short * pixel;
	
	if(numitem == 0 || numitem == 1) //CO_RGB24  RGB8888
	{
	uchar * bit= (uchar *)buffer;
	if(image->create(img_width, img_height, 32, 0, QImage::IgnoreEndian))
	{
	
	    for(y=0; y<img_height; y++)
	    {
		for(x=0; x<img_width; x++)
		{
		    r=(int)bit[i+2];
		    g=(int)bit[i+1];
		    b=(int)bit[i];        
		    point= (QRgb *)image->scanLine(y)+ x;
		    *point = qRgb(r,g,b);
		    if(numitem == 0)
			i+=3;
		    else
			i+=4;
		}
	    }
	}
	p->begin(this);
	p->drawImage(0,60, (*image));
	p->end();
        }
	

	if(numitem == 2)        //CO_RGB565
	{
	pixel = (unsigned short *)buffer;
	if(image->create(img_width, img_height, 32, 0, QImage::IgnoreEndian))
	{
	
	    for(y=0; y<img_height; y++)
	    {
		for(x=0; x<img_width; x++)
		{
		    r = ((*pixel & 0xF800) >> 8);
		    g = ((*pixel & 0x07E0) >> 3);
		    b = ((*pixel) & 0x001F)<<3;       
		    point= (QRgb *)image->scanLine(y)+ x;
		    *point = qRgb(r,g,b);
		    pixel++;
		}
	    }
	}
	p->begin(this);
	p->drawImage(0,60, (*image));
	p->end();
        }

	
	if(numitem == 3)            //RGB1555
	{    
	pixel = (unsigned short *)buffer;
	if(image->create(img_width, img_height, 32, 0, QImage::IgnoreEndian))
	{
	
	    for(y=0; y<img_height; y++)
	    {
		for(x=0; x<img_width; x++)
		{
		    r = ((*pixel & 0x7C00) >> 7);//<<1;
		    g = ((*pixel & 0x03E0) >> 2);
		    b = ((*pixel) & 0x001F)<<3;       
		    point= (QRgb *)image->scanLine(y)+ x;
		    *point = qRgb(r,g,b);
		    pixel++;
		}
	    }
	}
	p->begin(this);
	p->drawImage(0,60, (*image));
	p->end();
        }
	

	if(numitem == 4)  //RGB5515
	{    
	pixel = (unsigned short *)buffer;
	if(image->create(img_width, img_height, 32, 0, QImage::IgnoreEndian))
	{
	
	    for(y=0; y<img_height; y++)
	    {
		for(x=0; x<img_width; x++)
		{
		    r = ((*pixel & 0xF800) >> 8);
		    g = ((*pixel & 0x07C0) >> 5);
		    b = ((*pixel) & 0x001F) << 3;       
		    point= (QRgb *)image->scanLine(y)+ x;
		    *point = qRgb(r,g,b);
		    pixel++;
		}
	    }
	}
	p->begin(this);
	p->drawImage(0,60, (*image));
	p->end();
        }
#if 1	
	if(numitem == 5 )  //MONOCHOY8   RGB8332  || numitem ==1
	{  
	if(oneflag == 0)
	{
	    oneflag = 1;
 	//QImage   *image1;
	imageone=new QImage((uchar *)buffer,img_width, img_height,8,point1,256,QImage::IgnoreEndian);
        }
	else
	{
	    imageone->loadFromData((uchar *)buffer,img_width*img_height);
	    imageone->setColor ( 0, point1[0]);
	}

	p->begin(this);
	p->drawImage(0,60, (*imageone));
	p->end();
        }
#endif	
	
      }
}


void Form1::formresize()
{
    ((Form1 *)formObject)->resize( QSize(img_width, img_height+70));
}

void Form1::Offset()
{
    offsetdlg->show();
}


void Form1::opendev()
{
    odlg->show();
}


void Form1::copybuffer()
{
//      ((Form1 *)formObject)->Stop();
    MV_SetCallBack(fd,callbackBefore, NULL);
     ((Form1 *)formObject)->Start();
     ((Form1 *)formObject)->Play();
}


void Form1::updown()
{
    bupdown = 1 - bupdown;
    MV_SetDeviceParameter(fd, WORK_UPDOWN, bupdown);
}

void Form1::leftright()
{
    bfilp = 1 - bfilp;
    MV_SetDeviceParameter(fd, WORK_FLIP, bfilp);
}
